<?php
/*
 Payment modules - Base Plugin for all module
 */

require_once dirname(__FILE__) ."/constants.inc";
require_once dirname(__FILE__) ."/curl_util.class.inc";
require_once dirname(__FILE__) ."/../../log.php";

class base_plugin
{
    var $brand;
    var $code;
    var $connector;
    var $title;
    var $ctpe_url;
    var $description;
    var $enabled;
    var $unreliable_comment;
    var $configuration_data;
    var $configuration_name;
    var $payment_code;
    var $payment_currency;
    var $payment_mode;
    var $payment_method;
    var $payment_type;
    var $download_url;
    var $order_status;
    var $current_order;
    
    /**
     * @var parameter_integrator
     */
    var $request_parameters;
    
    /**
     * @var SimpleXMLElement
     */
    var $response_parameters;
    var $complete_redirect_url;
    var $main_redirect_url;
    var $parameters_to_post;

    var $has_header_group = true;
    var $has_user_login_group = true;
    var $authenticator;
    var $target_form;
    var $method_form = "POST";
    
    var $specific_channels;

    var $acknowledge_return_code = array
    (
        "000.000.000", //Transaction succeeded
        "000.100.110", //Request successfully processed in 'Merchant in Integrator Test Mode'
        "000.100.111", //Request successfully processed in 'Merchant in Validator Test Mode'
        "000.100.112", //Request successfully processed in 'Merchant in Connector Test Mode'
        "000.100.200", //Reason not Specified
        "000.100.201", //Account or Bank Details Incorrect
        "000.100.202", //Account Closed
        "000.100.203", //Insufficient Funds
        "000.100.204", //Mandate not Valid
        "000.100.205", //Mandate Cancelled
        "000.100.206", //Revocation or Dispute
        "000.100.207", //Cancellation in Clearing Network
        "000.100.208", //Account Blocked
        "000.100.209", //Account does not exist
        "000.100.210", //Invalid Amount
        "000.100.220", //Fraudulent Transaction
        "000.100.221", //Merchandise Not Received
        "000.100.222", //Transaction Not Recognized By Cardholder
        "000.100.223", //Service Not Rendered
        "000.100.224", //Duplicate Processing
        "000.100.225", //Credit Not Processed
        "000.100.230", //Unauthorised Charge
        "000.100.299", //Unspecified (Technical)
        "000.200.000", //Transaction pending
        "000.300.000", //Two-step transaction succeeded
        "000.400.000", //Transaction succeeded (please review manually due to fraud suspicion)
        "000.500.000", //Transaction succeeded - very good rating
        "000.500.100" //Transaction succeeded (address corrected)
    );

    function base_plugin ()
    {
        global $order;
        $this->configuration_name = "MODULE_PAYMENT_" . strtoupper($this->code);
        $this->title = @constant($this->configuration_name . "_TEXT_TITLE");
        $this->description = @constant($this->configuration_name . "_TEXT_DESCRIPTION");
        $this->sort_order = @constant($this->configuration_name . "_SORT_ORDER");
        $this->enabled = (@constant($this->configuration_name . "_STATUS") == 'True') ? true : false;
        $this->ctpe_url = @ constant($this->configuration_name. "_CTPE_URL");
        $this->unreliable_comment = @constant($this->configuration_name . "_UNRELIABLE_COMMENT");

        $os = (int) @constant($this->configuration_name . "_ORDER_STATUS_ID");
        if ($os > 0)
        {
            $this->order_status = $os;
        }
        if (is_object($order))
        {
            $this->update_status();
        }
        $this->ctpe_url = @constant($this->configuration_name . "_CTPE_URL");
	//$this->form_action_url=$this->ctpe_url;
	$this->tmpOrders=true;
        $this->download_url = HTTP_SERVER . DIR_WS_CATALOG . "../xtc_downloads/" . $this->code . '.zip';
    }


    /*
     * This method is called when the all the process for payment has been done.
     * Mostly, this method is called by plugin with direct response.
     */
    function after_process()
    {
    	global $db;
    	if ($this->order_status)
        {
            $db->Execute("UPDATE `" .TABLE_ORDERS . "` SET `orders_status`='" . $this->order_status . "' WHERE `orders_id`='" .$GLOBALS['insert_id']. "' ");
        }
    }

    function before_process()
    {
		return false;
    }

    function payment_action() {
    	global  $messageStack;
        $this->init_process();
        $this->curl_access();

        try
        {
            create_log($this->code ." was chosen for payment");
            $response = curl_util::send_and_load($this->ctpe_url, $this->request_parameters, $this->authenticator);
            create_log(null, null, null, "Response", $response);
        }
        catch (Exception $exc)
        {
        	$messageStack->add_session((string)$exc->getMessage());
            zen_redirect(zen_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL', true, false));
        }

        if ($this->is_request_success($response))
        {
            $this->process_request();
        }
        else
        {
        	$this->cancel_request();
        }
        if (isset($_SESSION['FRAME_URL']))
        {
            zen_redirect($_SESSION['FRAME_URL']);
        }

    }

    function init_process ()
    {
        global $order;

        $this->current_order = $order;
        $this->check_user_zone($this->current_order->billing['country']);
        $this->set_params();
    }

    function is_request_success($response)
    {
        return false;
    }

    function process_request()
    {
        return;
    }

    function cancel_request ()
    {
        return;
    }

    function get_shop_url ()
    {
        return;
    }

    function set_params ()
    {
    	global $db;
        //header
        $this->request_parameters->security_sender = @ constant($this->configuration_name._SECURITY_SENDER);
        //transaction attributes
        $this->request_parameters->mode = @ constant($this->configuration_name._MODE);
        $this->request_parameters->transaction_channel = @ constant($this->configuration_name."_TRANSACTION_CHANNEL");
        $this->request_parameters->source = @ constant($this->configuration_name._SOURCE);
        $this->request_parameters->response = @ constant($this->configuration_name._RESPONSE);
        //user login
        $this->request_parameters->user_login = @ constant($this->configuration_name._USER_LOGIN);
        $this->request_parameters->user_pwd = @ constant($this->configuration_name._USER_PWD);
        //identification
        $order_id_query_result = $db->Execute("SELECT `orders_id` as `id` FROM `" .TABLE_ORDERS. "` ORDER BY `orders_id` DESC LIMIT 1;");
        $this->request_parameters->identification_transaction = (string)($order_id_query_result->fields['id']);
        //payment
        if (isset($_SESSION['currency']) && $this->payment_currency != $_SESSION['currency'])
        {
            $this->payment_currency = $_SESSION['currency'];
        }
        $this->request_parameters->payment_presentation_currency = $this->payment_currency;
        $this->request_parameters->set_payment_amount($this->current_order->info['total']);
        $this->request_parameters->payment_presentation_usage = PRESENTATION_USAGE . " " . $this->request_parameters->identification_transaction;
        $this->request_parameters->identification_shopper = isset($_COOKIE['bu_']) ? $_COOKIE['bu_'] : null;
        //customer
        $this->set_parameters_customer();
    }

    function set_parameters_customer()
    {
        $this->request_parameters->customer_name_company = $this->current_order->billing['company'];
        $this->request_parameters->customer_name_family = $this->current_order->billing['firstname'];
        $this->request_parameters->customer_name_given = $this->current_order->billing['lastname'];
        $this->request_parameters->customer_name_salutation = $this->current_order->billing['salutation'];
        $this->request_parameters->customer_name_title = $this->current_order->billing['title'];
        $this->request_parameters->customer_address_city = $this->current_order->billing['city'];
        $this->request_parameters->customer_address_country = $this->current_order->billing['country']['iso_code_2'];
        $this->request_parameters->customer_address_state = $this->current_order->billing['state'];
        $this->request_parameters->customer_address_street = $this->current_order->billing['street_address'];
        $this->request_parameters->customer_address_zip = $this->current_order->billing['postcode'];
        $this->request_parameters->customer_contact_email = $this->current_order->customer['email_address'];
        $this->request_parameters->customer_contact_phone = $this->current_order->customer['telephone'];
        $this->request_parameters->customer_contact_ip = ($_SERVER["HTTP_X_FORWARDED_FOR"]) ? $_SERVER["HTTP_X_FORWARDED_FOR"] : $_SERVER["REMOTE_ADDR"];
    }

    /**
     * Check the number of configuration value of current module payment status.
     */
    function check()
    {
    	global $db;
        if (!isset ($this->_check))
        {
            $check_query = $db->Execute("SELECT `configuration_value` FROM `" . TABLE_CONFIGURATION . "` WHERE `configuration_key` = '" . $this->configuration_name . "_STATUS'");
            $this->_check = $check_query->RecordCount();
        }
        return $this->_check;
    }

    function check_user_zone ($user_country)
    {
        if (!defined($this->configuration_name. "_ALLOWED_COUNTRIES"))
        {
            return;
        }
        if (!preg_match("/[A-Z,]{2}/", constant($this->configuration_name. "_ALLOWED_COUNTRIES")))
        {
            return;
        }
    }

    function confirmation()
    {
        return false;
    }

    function get_error()
    {
        $error = @constant($_GET['payment_error_type']). " Error-Code: " .$_GET['payment_error_code'];
        if ($error)
        {
            $error .= @constant($this->configuration_name . "_TEXT_ERROR_DESC");
        }

        return array ('title' => @constant($this->configuration_name . "_TEXT_ERROR"), 'error' => $error);
    }

    function install()
    {
    	global $db;
        $fields = null;
        $mysql_queries = array();
        foreach ($this->load_configuration_data()->insert as $insert)
        {
            $config = null;
            $config['configuration_key'] = $this->configuration_name. "_" .$insert->configuration_key;
            $config['configuration_value'] = $insert->configuration_value;
            $config['configuration_group_id'] = $insert->configuration_group_id;
            $config['sort_order'] = $insert->sort_order;
            $config['date_added'] = $insert->date_added;

            $config['last_modified'] = !empty ($insert->last_modified) ? $insert->last_modified : "NULL";
            $config['set_function'] = "NULL";
            if (!empty ($insert->set_function))
            {
                $config['set_function'] = $insert->set_function;
                $config['set_function'] = preg_replace ("/(configuration\[)([A-Z_]{4,}\])/", '$1'.$this->configuration_name.'_$2', $config['set_function']);
            }
            $config['use_function'] = !empty ($insert->use_function) ? $insert->use_function : "NULL";

            include(DIR_FS_CATALOG . DIR_WS_LANGUAGES . $_SESSION['language'] . '/modules/payment/' . $this->code . '.php');
            $config['configuration_title'] = @constant($config['configuration_key'] . "_TITLE");
            $config['configuration_description'] = @constant($config['configuration_key'] . "_DESC");
            
            if (is_null($fields))
            {
                $fields = "`" . implode("`, `", array_keys($config)) . "`";
            }

            $values = str_replace(array("'" . $insert->date_added . "'", "'NULL'"), array($insert->date_added, "NULL"), "'" . implode("', '", array_values($config)) . "'");
            $mysql_queries [] = "(" . $values . ")";
        }
        $db->Execute("INSERT INTO " . TABLE_CONFIGURATION . " (" . $fields . ") VALUES " . implode(", ", $mysql_queries));
    }

    function javascript_validation()
    {
        return false;
    }

    function keys()
    {
        $return = array ();
        foreach ($this->load_configuration_data()->insert as $insert)
        {
            $return[] =  $this->configuration_name. "_" .(string) $insert->configuration_key;
        }

        return $return;
    }

    function pre_confirmation_check()
    {
        return false;
    }

    function process_button()
    {
        return zen_draw_hidden_field($this->code . '_request', 1) . "\n" . zen_draw_hidden_field('total_amount', $this->current_order->info['total']) . "\n" . $this->get_form();
    }

    function get_form()
    {
        return $this->fetch_currency_change($this->current_order);
    }

    function fetch_currency_change ($order, $simple = false)
    {
    	global $currencies;
        $default_currency = zen_currency_exists(EURO_CURRENCY) ? EURO_CURRENCY : DEFAULT_CURRENCY;
        if (!is_null($this->payment_currency) && $this->payment_currency != $default_currency)
        {
            $smarty = new Smarty();
            $pi = new parameter_integrator();
                
            $pi->payment_presentation_currency = $this->payment_currency;
            $pi->set_payment_amount($order->info['total']);
                
            $smarty->assign("loaded_file", DIR_FS_CATALOG . DIR_WS_LANGUAGES . $_SESSION['language'] . "/modules/payment/payment.lang.conf");
            $smarty->assign("CURRENCY_FROM", $default_currency);
            $smarty->assign("CURRENCY_TO", $this->payment_currency);
            
            $amount_from = $order->info['total'] * ($currencies->get_value($default_currency) / $currencies->get_value($this->payment_currency));
            $decimal_place = $currencies->get_decimal_places($default_currency);
            $amount_from = number_format($amount_from, $decimal_place);
            $smarty->assign("AMOUNT_FROM",  $amount_from ." " .$default_currency);
            $smarty->assign("AMOUNT_TO", $pi->payment_presentation_amount. " " .$this->payment_currency);
                
            //$base_ex = $xtPrice->xtcCalculateCurrEx("1", $this->payment_currency);
            $base_ex = $pi->payment_presentation_amount / $amount_from;
            $decimal_place = $currencies->get_decimal_places($this->payment_currency);
            $base_currency_change = number_format($base_ex, $decimal_place) ." " .$this->payment_currency;
            $smarty->assign("BASE_EXCHANGE", number_format("1", $default_currency) ." $default_currency = " .$base_currency_change);
            
            if (!$simple)
            {
                $currency_box = $smarty->fetch(CURRENT_TEMPLATE . '/module/payment/currency_exchange_info_block.html');
                $smarty->assign("CURRENCY_EX_BOX", $currency_box);
            }
                
            return $smarty->fetch(CURRENT_TEMPLATE . '/module/payment/currency_exchange_info' .(!$simple?'':'_block') .'.html');
        }
        return null;
    }

    /*
     * Uninstalling the plugin from the system.
     */
    function remove()
    {
    	global $db;
        $db->Execute("DELETE FROM `" . TABLE_CONFIGURATION . "` WHERE `configuration_key` REGEXP '" . $this->configuration_name ."_*' ");
    }

    function selection()
    {
        global $order;
        
        $title_name = @constant($this->configuration_name ."_TEXT_DESCRIPTION");
        if (!is_null($title_name))
        {
            $title_name = @constant($this->configuration_name ."_TEXT_DESC");
        }

        return array (
            'id' => $this->code,
            'module' => $this->title,
            'url_download' => $this->download_url,
            'unreliable_comment' => $this->unreliable_comment,
            'description' => $this->fetch_currency_change($order, true),
            'title_name' => @constant($this->configuration_name ."_TEXT_DESCRIPTION"),
            'is_configured' => strtolower(@constant($this->configuration_name ."_CONFIGURED")) === 'true',
        );
    }

    function update_status()
    {
        global $order, $db;

        $this->current_order = $order;

        if (($this->enabled == true) && ((int) @constant($this->configuration_name . "_ZONE") > 0))
        {
            $check_flag = false;
            $check_query = $db->Execute("SELECT `zone_id` FROM `" . TABLE_ZONES_TO_GEO_ZONES . "` " .
                                                                "WHERE `geo_zone_id` = '" . @constant($this->configuration_name . "_ZONE") . "' " .
                                                                "AND `zone_country_id` = '" . $this->current_order->billing['country']['id'] . "' " .
                                                                "ORDER BY `zone_id`");

            while (!$check_query->EOF)
            {
                if (($check_query->fields['zone_id'] < 1) || ($check_query->fields['zone_id'] == $this->current_order->billing['zone_id']))
                {
                    $check_flag = true;
                    break;
                }
                $check_query->MoveNext();
            }

            if ($check_flag == false)
            {
                $this->enabled = false;
            }
        }
	$this->checkAddresses();
    }

    function checkAddresses() {
        global $order;
	if($this->enabled) {
            $billing = $order->billing;
	    $delivery = $order->delivery;
	    $this->enabled = ($billing == $delivery);
	}
    }


    /**
     * Default configuration data is stored in xml file, it is loaded when install the plugin.
     */
    function load_configuration_data()
    {
        if ($this->configuration_data == null)
        {
            $configuration_path = DIR_FS_CATALOG . DIR_WS_MODULES ."payment/xml/install." . $this->code . ".xml";
            try
            {
                $this->configuration_data = @ new SimpleXMLElement($configuration_path, LIBXML_NOBLANKS, true);
            }
            catch (Exception $e)
            {
                echo '<span style="color:red">' .$this->code. " : " .$e->getMessage(). '</span>';
            }
        }

        return $this->configuration_data;
    }

    function get_payment_code($method, $type)
    {
        return $method.".".$type;
    }
    
    /**
     * Used where the shop is accessed through cUrl, e.g, in einvoice process.
     * The cUrl caller has to send data required in COOKIEs.
     * 
     * @return null
     */
    function curl_access ()
    {
        $additional_query = array(
            COOKIEKEY_ALTERNATEURL_SUCCESS=> $_COOKIE[$this->code ."_" .COOKIEKEY_ALTERNATEURL_SUCCESS],
            COOKIEKEY_ALTERNATEURL_CONTINUE=> $_COOKIE[$this->code ."_" .COOKIEKEY_ALTERNATEURL_CONTINUE],
            COOKIEKEY_ALTERNATEURL_FAILED=> $_COOKIE[$this->code ."_" .COOKIEKEY_ALTERNATEURL_FAILED],
        );
        $query = http_build_query($additional_query, "", "&");
        
        if (!empty($this->request_parameters->frontend_response_url) &&
            !empty($query))
        {
            $delimiter = (preg_match('/\?*[^=&?]+=[^&]*/', $this->request_parameters->frontend_response_url)!=0) ? '&' : '?';
            $this->request_parameters->frontend_response_url .= $delimiter .$query;
        }
    }
    
    function after_order_create($order_id) {
    	global $db;
    	// set order status to 0 before payment is accepted
    	$db->Execute("update " . TABLE_ORDERS . " set orders_status = 0 where orders_id = '" . (int)$order_id . "'");
    }
    
    function country_allowed($country) { 
    	$allowed_countries = @constant($this->configuration_name . "_ALLOWED_COUNTRIES");
    	return !(strlen($allowed_countries) > 0 && stripos($allowed_countries, $country) === false);
    }
}
?>
