<?php

require_once dirname(__FILE__) . "/parameter_integrator.class.inc";

class xml_integrator extends parameter_integrator
{

    var $riskmanagement_process;
    /**
     * @access private
     * @var SimpleXMLElement
     */
    var $simple_xml_element;
    var $testadvice;
    var $anaylisis_criterion;

    function xml_integrator()
    {
        $this->simple_xml_element = new SimpleXMLElement(DIR_FS_CATALOG . "includes/modules/payment/xml/xmlrequest.xml", null, true);
    }

    function marshall()
    {
        $dom_request = new DomDocument('1.0', 'UTF-8');
        $dom_request->formatOutput = true;
        $this->generate_tags($this->simple_xml_element, $dom_request, $dom_request);

        return $dom_request->saveXML();
    }

    function generate_tags(SimpleXMLElement $sxe, DomNode $parent, DomDocument &$dom_root)
    {
        $sxe_text = (string) $sxe;
        $sxe_children = $sxe->children();
        $sxe_name = $sxe->getName();
        $regex = "/[a-z_]+/";
        $tmp_dom = $dom_root->appendChild($dom_root->createElement($sxe_name));

        foreach ($sxe->attributes() as $k => $v)
        {
            if (empty($v) || !preg_match($regex, $v))
            {
                continue;
            }

            $attribute_value = $this->{(string) $v};
            if (!is_null($attribute_value))
            {
                $tmp_dom->setAttribute($k, $attribute_value);
            }
        }

        if (count($sxe_children) == 0 &&
                preg_match($regex, $sxe_text) &&
                !is_null($this->{$sxe_text}))
        {
            $node_value = $this->{$sxe_text};

            if (is_string($node_value))
            {
                $tmp_dom->appendChild($dom_root->createTextNode($node_value));
            }
            elseif (is_array($node_value))
            {
                // generate the tags with the form <A name="value1">TextValue1</A><A name="value2">TextValue2</A>...<A name="valuen">TextValueN</A>
                $dom_root->removeChild($tmp_dom);
                foreach ($node_value as $k => $v)
                {
                    if (is_array($v) && !is_null($v['comment']))
                    {
                        $_v = $v[0];
                        $_dom = $parent->appendChild($dom_root->createComment($v['comment']));
                        $_dom->appendChild($dom_root->createTextNode($_v));
                    }
                    else
                    {
                        $_v = $v;
                    }

                    $_dom = $parent->appendChild(new DomElement($sxe_name));
                    $_dom->setAttribute("name", $k);
                    $_dom->appendChild($dom_root->createTextNode($_v));
                }
                return;
            }
        }
        elseif (count($sxe_children) > 0)
        {
            foreach ($sxe->children() as $child)
            {
                $this->generate_tags($child, $tmp_dom, $dom_root);
            }
        }

        if ($tmp_dom->hasChildNodes() || $tmp_dom->hasAttributes())
        {
            $parent->appendChild($tmp_dom);
        }
        else
        {
            $dom_root->removeChild($tmp_dom);
        }

        return $tmp_dom;
    }

    function xml_shift_element($_source, $_shifted, $_locator)
    {
        $sxe = @ new SimpleXMLElement($_source);
        $xml = @ new SimpleXMLElement("<root>" .$_shifted ."</root>");
        $_locator = str_replace("/", "->", $_locator);
        
        eval('$parent = $sxe' . ($_locator!=='' ? '->' .$_locator : '' ) . ';');
        self::_add_xml_content($xml, $parent);

        $new_dom = new DomDocument('1.0', 'UTF-8');
        $new_dom->formatOutput = true;
        $new_dom->loadXML($sxe->asXML(), LIBXML_NOBLANKS);

        return new SimpleXMLElement($new_dom->saveXML());
    }

    /**
     * @access private
     * @param SimpleXMLElement $_child
     * @param SimpleXMLElement $_parent
     */
    function _add_xml_content(SimpleXMLElement $_child, SimpleXMLElement &$_parent)
    {
        foreach ($_child as $ch)
        {
            $child = $_parent->addChild($ch->getName(), (string) $ch);
            foreach ($ch->attributes() as $k => $v)
            {
                $child->addAttribute($k, $v);
            }
            if ($ch->children())
            {
                self::_add_xml_content($ch, $child);
            }
        }
    }

}

?>
