<?php
/*
 Payment modules - XML Paysafecard Module
*/

require_once dirname(__FILE__) ."/xml_asynchronous.class.inc";
require_once dirname(__FILE__) ."/payolution.class.inc";

class xml_payolution_installment extends xml_asynchronous
{
	function xml_payolution_installment ()
	{
		$this->code = strtolower(__CLASS__);
		$this->brand = "PAYOLUTION_INS";
		$this->connector = "SimpleChannel";
		parent::xml_asynchronous();
	}

	function set_params ()
	{
		parent :: set_params();

		$this->request_parameters->account_id = null;
		$this->request_parameters->payment_code = base_plugin::get_payment_code(ONLINEPAYMENT_METHOD_WALLETPAYMENT, PAYMENT_TYPE_PREAUTHORISATION);
		$this->request_parameters->frontend_session_id = zen_session_id();

		payolution::set_criterion_params($this);
	}

	function update_status() {
		parent :: update_status();
		if($this->enabled) {
			$upper_bound = @constant($this->configuration_name . "_TRANSACTION_LIMIT_UB");
			$temp_total = $this->current_order->info['total'];
			$lower_bound = @constant($this->configuration_name . "_TRANSACTION_LIMIT_LB");
			$country = $this->current_order->billing['country']['iso_code_2'];
			if($temp_total > $upper_bound || $temp_total < $lower_bound || !$this->country_allowed($country)) {
				$this->enabled = false;
			}
		}
	}

	function selection() {
		global $order;
		$form_array = array ();

		$selection = array ('id' => $this->code, 'module' => $this->title, 'fields' => $form_array, 'description' => $this->description);

		return $selection;
	}

	function admin_order($oID) {
		global $db;
		$oID = (int) $oID;
		$query_result = $db->Execute("SELECT * FROM payment_xml_payolution_installment WHERE pol_ORDERID = '" . $oID . "'");
		if ($query_result->fields['pol_CAPTURE_RESULT'] != null) {
			$capture_message_html = '
			<tr>
			<td class="main"><b>' . MODULE_PAYMENT_XML_PAYOLUTION_INSTALLMENT_TEXT_CAPTURE_RESULT . '</b></td>
			<td class="main">' . $query_result->fields['pol_CAPTURE_MESSAGE'] . '</td>
			</tr>
			';
			echo $capture_message_html;
		}
		if ($query_result->fields['pol_CAPTURE_RESULT'] == null || $query_result->fields['pol_CAPTURE_RESULT'] == 'NOK') {
			$capture_button_html = '
			<tr>
			<td class="main" colspan="2"><a class="button" href="' . zen_href_link('send_capture.php', zen_get_all_get_params(array())) . '">' . MODULE_PAYMENT_XML_PAYOLUTION_INSTALLMENT_TEXT_SEND_CAPTURE . '</a></td>
			</tr>
			';
			echo $capture_button_html;
		}
	}

	function install() {
		global $db;
		parent :: install();
		$pol_installed = false;
		$tables = mysql_list_tables(DB_DATABASE);
		while ($row = mysql_fetch_row($tables)) {
			if ($row[0] == 'payment_xml_payolution_installment') $pol_installed=true;
		}

		if ($pol_installed==false) {
			$db->Execute("CREATE TABLE payment_xml_payolution_installment (pol_ORDERID int(11) unsigned NOT NULL default '0', pol_PREAUTHID varchar(255) NOT NULL default '', pol_CAPTURE_RESULT char(3) default NULL, pol_CAPTURE_MESSAGE varchar(255) default NULL)");
		}

	}

	function process_request() {
		global $db;
		global $insert_id;
		$transaction_details = $this->response_parameters->xpath('/Response/Transaction/Identification/UniqueID');
		if(isset($transaction_details) && isset($transaction_details[0])) {
			$payolution_order_id = $insert_id;
			$payolution_preauth_id = (string) $transaction_details[0];
			$db->Execute("INSERT INTO payment_xml_payolution_installment (pol_ORDERID, pol_PREAUTHID) VALUES('" . zen_db_input($payolution_order_id) . "', '" . zen_db_input($payolution_preauth_id) . "')");
		}
		return parent :: process_request();
	}


}
?>
