<?php
/*
  Payment modules - XML Paysafecard Module
*/

require_once dirname(__FILE__) ."/xml_synchronous.class.inc";
require_once dirname(__FILE__) ."/payolution.class.inc";

class xml_payolution_invoice extends xml_synchronous
{

	function xml_payolution_invoice ()
    {
        $this->code = strtolower(__CLASS__);
		$this->brand = "PAYOLUTION_INVOICE";
		$this->connector = "SimpleChannel";
		parent::xml_synchronous();
    }

    function set_params ()
	{
		parent :: set_params();

		$this->request_parameters->account_id = null;
		$this->request_parameters->payment_code = base_plugin::get_payment_code(ONLINEPAYMENT_METHOD_WALLETPAYMENT, PAYMENT_TYPE_PREAUTHORISATION);
		$this->request_parameters->customer_birth_date = $_SESSION['payolution_dob'];	
		payolution::set_criterion_params($this);
	}
    
     function update_status() {
         parent :: update_status();
         if($this->enabled) {
           $upper_bound = @constant($this->configuration_name . "_TRANSACTION_LIMIT_UB");
           $temp_total = $this->current_order->info['total'];
           $lower_bound = @constant($this->configuration_name . "_TRANSACTION_LIMIT_LB");
           $country = $this->current_order->billing['country']['iso_code_2'];
           if($temp_total > $upper_bound || $temp_total < $lower_bound || !$this->country_allowed($country)) {
               $this->enabled = false;
           }
         }
     }

	function javascript_validation() {
		$js = ' if (payment_value == "'.$this->code.'") {'."\n".'    var dob_year = document.checkout_payment.payolution_dob_year.value;'."\n".'    var dob_month = document.checkout_payment.payolution_dob_month.value;'."\n".' var dob_day = document.checkout_payment.payolution_dob_day.value;'."\n".'  if (dob_year == "" || dob_month == "" || dob_day == "") {'."\n".'      error_message = error_message + unescape("'.$this->js_lang(MODULE_PAYMENT_XML_PAYOLUTION_INVOICE_TEXT_JS_DOB).'");'."\n".'   error = 1;'."\n".'  }'."\n".'else { var month_r = dob_month -1; var testDate = new Date(dob_year, month_r, dob_day); if (testDate.getDate()!=dob_day || testDate.getMonth()!=month_r || testDate.getFullYear()!=dob_year) {'."\n".'      error_message = error_message + unescape("'.$this->js_lang(MODULE_PAYMENT_XML_PAYOLUTION_INVOICE_TEXT_JS_DOB).'");'."\n".'      error = 1;'."\n".'  }'."\n".' else { var ref_date = new Date(); var age = ref_date.getFullYear() - testDate.getFullYear(); if(ref_date.getMonth() < testDate.getMonth() || (ref_date.getMonth() == testDate.getMonth() && ref_date.getDate() < testDate.getDate())) {age -= 1;}; if (age < 18) {'."\n".'      error_message = error_message + unescape("'.$this->js_lang(MODULE_PAYMENT_XML_PAYOLUTION_INVOICE_TEXT_JS_DOB_AGE).'");'."\n".'      error = 1;'."\n".'    }'."\n".' }'."\n" . ' } '."\n" . ' } ' ."\n";
		return $js;
	}

        function selection() {
                global $order;
                $form_array = array ();

                // expire date
                $form_array = array_merge($form_array, array (array ('title' => MODULE_PAYMENT_XML_PAYOLUTION_INVOICE_TEXT_DOB, 'field' => zen_draw_input_field('payolution_dob_day', '', 'size="2"').'&nbsp;'.zen_draw_input_field('payolution_dob_month', '', 'size="2"').'&nbsp;'.zen_draw_input_field('payolution_dob_year', '', 'size="4"'))));

                $selection = array ('id' => $this->code, 'module' => $this->title, 'fields' => $form_array, 'description' => $this->description);

                return $selection;
        }

	function confirmation() {
		$_SESSION['payolution_dob'] = $_POST['payolution_dob_year'] . '-' . $_POST['payolution_dob_month'] . '-' . $_POST['payolution_dob_day'];
	}

    function admin_order($oID) {
    	global $db;
        $oID = (int) $oID;
        $query_result = $db->Execute("SELECT * FROM payment_xml_payolution_invoice WHERE pol_ORDERID = '" . $oID . "'");
        $invoice_id_html = '
        	<tr>
				<td class="main"><b>' . MODULE_PAYMENT_XML_PAYOLUTION_INVOICE_TEXT_INVOICE_ID . '</b></td>
				<td class="main">' . $query_result->fields['pol_INVID'] . '</td>
			</tr>
			';
        echo $invoice_id_html;
        if ($query_result->fields['pol_CAPTURE_RESULT'] != null) {
        	$capture_message_html = '
        		<tr>
					<td class="main"><b>' . MODULE_PAYMENT_XML_PAYOLUTION_INVOICE_TEXT_CAPTURE_RESULT . '</b></td>
					<td class="main">' . $query_result->fields['pol_CAPTURE_MESSAGE'] . '</td>
				</tr>        	
        		';
        	echo $capture_message_html;
        }
        if ($query_result->fields['pol_CAPTURE_RESULT'] == null || $query_result->fields['pol_CAPTURE_RESULT'] == 'NOK') {
        	$capture_button_html = '
                <tr>
                  	<td class="main" colspan="2"><a class="button" href="' . zen_href_link('send_capture.php', zen_get_all_get_params(array())) . '">' . MODULE_PAYMENT_XML_PAYOLUTION_INVOICE_TEXT_SEND_CAPTURE . '</a></td>
                </tr>					
                ';
        	echo $capture_button_html;                
        }
    }

	function install() {
		global $db;
		parent :: install();
		$pol_installed = false;
    	$tables = mysql_list_tables(DB_DATABASE);
        while ($row = mysql_fetch_row($tables)) {
        	if ($row[0] == 'payment_xml_payolution_invoice') $pol_installed=true;
        }

        if ($pol_installed==false) {
        	$db->Execute("CREATE TABLE payment_xml_payolution_invoice (pol_INVID varchar(255) NOT NULL default '', pol_ORDERID int(11) unsigned NOT NULL default '0', pol_PREAUTHID varchar(255) NOT NULL default '', pol_CAPTURE_RESULT char(3) default NULL, pol_CAPTURE_MESSAGE varchar(255) default NULL, PRIMARY KEY  (pol_INVID))");
        }
	}

	function process_request() {
		global $db;
		global $insert_id;
		$connector_details = $this->response_parameters->xpath('/Response/Transaction/Processing/ConnectorDetails/Result');
		$transaction_details = $this->response_parameters->xpath('/Response/Transaction/Identification/UniqueID');
		if(isset($connector_details) && isset($connector_details[0]) && isset($transaction_details) && isset($transaction_details[0])) {
			$payolution_invoice_id = (string) $connector_details[0];
			$payolution_order_id = $insert_id;		
			$payolution_preauth_id = (string) $transaction_details[0];		
			$db->Execute("INSERT INTO payment_xml_payolution_invoice (pol_INVID, pol_ORDERID, pol_PREAUTHID) VALUES('" . zen_db_input($payolution_invoice_id) . "', '" . zen_db_input($payolution_order_id) . "', '" . zen_db_input($payolution_preauth_id) . "')");
		}
		return parent :: process_request();
	}

	function js_lang($message) {
		$message = str_replace ("&auml;","%E4", $message );
		$message = str_replace ("&Auml;","%C4", $message );
		$message = str_replace ("&ouml;","%F6", $message );
		$message = str_replace ("&Ouml;","%D6", $message );
		$message = str_replace ("&uuml;","%FC", $message );
		$message = str_replace ("&Uuml;","%DC", $message );
		return $message;
	}	
}
?>
